<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      MioCart 3.5                                                       
           MioCart PHP Shopping Cart - MioCart.Com 17/08/2008              ***
  ***                                                                      ***
  ****************************************************************************
*/



	@set_time_limit(900);
	include_once("./admin_config.php");
	include_once($root_folder_path . "includes/common.php");
	include_once("./admin_common.php");
	include_once($root_folder_path . "includes/record.php");
	include_once($root_folder_path . "messages/" . $language_code . "/cart_messages.php");

	check_admin_security("articles");

	$category_id = get_param("category_id");
	$parent_category_id = get_param("parent_category_id");
	if(!strlen($category_id)) { $category_id = "0"; }

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main", "admin_article_items_related.html");

	$t->set_var("admin_articles_top_href", "admin_articles_top.php");
	$t->set_var("admin_articles_href", "admin_articles.php");
	$t->set_var("admin_article_category_items_related_href", "admin_article_category_items_related.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");
	$t->set_var("admin_product_href", "admin_product.php");
	$t->set_var("related_items", "");
	$t->set_var("available_items", "");

	$sql  = " SELECT category_name FROM " . $table_prefix . "articles_categories ";
	$sql .= " WHERE category_id=" . $db->tosql($category_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$t->set_var("category_name", get_translation($db->f("category_name")));
	} else {
		die(OBJECT_NO_EXISTS_MSG);
	}

	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "articles_categories", "tree", "");
	$tree->show($category_id);

	$operation = get_param("operation");
	if ($parent_category_id == 0) {
		$return_page = "admin_articles_top.php?category_id=" . $parent_category_id;
	} else {
		$return_page = "admin_articles.php?category_id=" . $parent_category_id;
	}
	$errors = "";

	if ($operation == "cancel")
	{
		header("Location: " . $return_page);
		exit;
	}
	elseif ($operation == "save")
	{
		$related_ids = get_param("related_ids");

		if (!strlen($errors))
		{
			$related_ids = split(",", $related_ids);
			$db->query("DELETE FROM " . $table_prefix . "articles_categories_items WHERE category_id=" . $category_id);
			for ($i = 0; $i < sizeof($related_ids); $i++) {
				if (strlen($related_ids[$i])) {
					$related_order = $i + 1;
					$sql  = " INSERT INTO " . $table_prefix . "articles_categories_items (category_id, item_id, related_order) VALUES (";
					$sql .= $category_id . "," . $db->tosql($related_ids[$i], INTEGER) . "," . $related_order . ")";
					$db->query($sql);
				}
			}
			header("Location: " . $return_page);
			exit;
		}
	}

	$sql  = " SELECT ac.item_id AS related_id, i.item_id, i.item_name ";
	$sql .= " FROM (" . $table_prefix . "items i ";
	$sql .= " LEFT JOIN " . $table_prefix . "articles_categories_items ac ON (ac.item_id=i.item_id ";
	$sql .= " AND ac.category_id=" . $db->tosql($category_id, INTEGER) . ")) ";
	$sql .= " ORDER BY ac.related_order, i.item_name ";
	$db->query($sql);
	while ($db->next_record())
	{
		$row_item_id = $db->f("item_id");
		$related_id = $db->f("related_id");
		$related_name = $db->f("item_name");
		$t->set_var("related_id", $row_item_id);
		$t->set_var("related_name", str_replace("\"", "&quot;", $related_name));
		if ($row_item_id == $related_id) {
			$t->parse("related_items", true);
		} else {
			$t->parse("available_items", true);
		}
	}

	if (strlen($errors))	{
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	} else {
		$t->set_var("errors", "");
	}

	$t->set_var("category_id", $category_id);

	include_once("./admin_header.php");
	include_once("./admin_footer.php");

	$t->pparse("main");

?>